/**
 * @file Phase10Deck.h
 *
 * @brief Classes to represent deck of Phase 10 cards
 *
 * @ingroup CommonTypes
 *
 * @author Devon Johnson
 *
 */

#pragma once

// Includes
#include <functional>
#include <list>

#include <Phase10/Card.h>

namespace Phase10
{
  //-------------------------------------------------------------------------//
  // Class:       DeckParam
  // Description: Parameters for creating deck of cards
  //-------------------------------------------------------------------------//
  struct DeckParam
  {
    ///////////////////////////////////////////////////////////////////////////
    /// @brief Constructor
    /// @param _card - card to add
    /// @param _count - number of instances
    ///////////////////////////////////////////////////////////////////////////
    DeckParam(const Card& _card, size_t _count = 1) : card(_card), count(_count)
    {
    }

    // Struct variables
    Card   card;  ///< card to insert
    size_t count; ///< number of instances of this card
  };

  // Typedefs
  using DeckParams = std::list<DeckParam>;

  //-------------------------------------------------------------------------//
  // Class:       Deck
  // Description: Deck of Phase 10 cards
  //-------------------------------------------------------------------------//
  class Deck
  {
  public:
    // Public types
    using CardList = std::list<Card>;
    using Listener = std::function<void()>;

    using const_iterator         = typename CardList::const_iterator;
    using const_reverse_iterator = typename CardList::const_reverse_iterator;

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Constructor
    /// @param cards - cards to initially add
    /// @param mode - deck mode
    ///////////////////////////////////////////////////////////////////////////
    Deck(const DeckParams& cards, DeckMode mode = MODE_LIFO);
    Deck(DeckMode mode = MODE_LIFO);

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Destructor
    ///////////////////////////////////////////////////////////////////////////
    virtual ~Deck() = default;

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Adds a card to deck
    /// @param card - card to add
    /// @return - true if added, else false
    ///////////////////////////////////////////////////////////////////////////
    bool add(const Card& card);

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Adds multiple cards to the deck
    /// @param cards - cards to add
    /// @return - true if added, else false
    ///////////////////////////////////////////////////////////////////////////
    bool add(const CardList& card);

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Adds a listener for updates to this deck
    /// @param listener - new listener to add
    /// @return - None
    ///////////////////////////////////////////////////////////////////////////
    void addListener(const Listener& listener);

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Gets the last card
    /// @return - last card
    ///////////////////////////////////////////////////////////////////////////
    const Card& back() const { return mCards.back(); }

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Gets the starting iterator
    /// @return - starting iterator
    ///////////////////////////////////////////////////////////////////////////
    const_iterator begin() const { return mCards.begin(); }

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Clears all the cards from the deck
    /// @return - None
    ///////////////////////////////////////////////////////////////////////////
    void clear();

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Determines if the deck is empty
    /// @return - true if empty, else false
    ///////////////////////////////////////////////////////////////////////////
    bool empty() const;

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Gets the ending iterator
    /// @return - ending iterator
    ///////////////////////////////////////////////////////////////////////////
    const_iterator end() const { return mCards.end(); }

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Gets the first card
    /// @return - first card
    ///////////////////////////////////////////////////////////////////////////
    const Card& front() const { return mCards.front(); }

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Gets the cards message
    /// @param msg[out] - message for cards
    /// @return - None
    ///////////////////////////////////////////////////////////////////////////
    void getCards(Messages::DeckMsg& msg) const;

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Gets the point value for this deck
    /// @return - points for this deck
    ///////////////////////////////////////////////////////////////////////////
    size_t getPoints() const;

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Determines if the deck is locked for editing
    /// @return - true if locked, else false
    ///////////////////////////////////////////////////////////////////////////
    bool isLocked() const { return mLocked; }

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Determines if sorting is enabled
    /// @return - true if sorting is enabled, else false
    ///////////////////////////////////////////////////////////////////////////
    bool isSortingEnabled() const;

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Passes all cards to the requested deck
    /// @param other[i/o] - other deck to pass to
    /// @return - true if passed, else false
    ///////////////////////////////////////////////////////////////////////////
    bool passAll(Deck& other);

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Passes a card to the requested deck
    /// @param other[i/o] - other deck to pass to
    /// @return - true if successfully passed, else false
    ///////////////////////////////////////////////////////////////////////////
    bool passTo(Deck& other);

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Passes a card to the requested deck
    /// @param card - card to pass
    /// @param other[i/o] - other deck to pass to
    /// @return - true if successfully passed, else false
    ///////////////////////////////////////////////////////////////////////////
    bool passTo(const Card& card, Deck& other);

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Gets the next card in the deck without removing it
    /// @param card[out] - next card
    /// @return - true if deck is nonempty, else false
    ///////////////////////////////////////////////////////////////////////////
    bool peek(Card& card) const;

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Removes the next card from the deck
    /// @param card[out] - next card
    /// @return - true if deck is nonempty, else false
    ///////////////////////////////////////////////////////////////////////////
    bool pop();
    bool pop(Card& card);

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Gets the starting reverse iterator
    /// @return - starting reverse iterator
    ///////////////////////////////////////////////////////////////////////////
    const_reverse_iterator rbegin() const { return mCards.rbegin(); }

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Removes the requested card
    ///   NOTE: If multiple instances of card in the deck, removes first one
    /// @param card - card to remove
    /// @return - true if card is present in the deck, else false
    ///////////////////////////////////////////////////////////////////////////
    bool remove(const Card& card);

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Gets the ending reverse iterator
    /// @return - ending reverse iterator
    ///////////////////////////////////////////////////////////////////////////
    const_reverse_iterator rend() const { return mCards.rend(); }

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Sets the cards
    /// @param msg - update message
    /// @return - None
    ///////////////////////////////////////////////////////////////////////////
    void setCards(const Messages::DeckMsg& msg);
    void setCards(const Deck& other);

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Sets the deck mode
    /// @param mode - new deck mode
    /// @return - None
    ///////////////////////////////////////////////////////////////////////////
    void setMode(DeckMode mode);

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Shuffles the deck
    ///   NOTE: Does nothing if sorting is enabled
    /// @return - None
    ///////////////////////////////////////////////////////////////////////////
    void shuffle();

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Gets the number of cards in the deck
    /// @return - number of cards in the deck
    ///////////////////////////////////////////////////////////////////////////
    size_t size() const { return mCards.size(); }

  private:
    // Allow Match and Player to call setLocked
    friend class Match;
    friend class Player;

    // Private class variables
    bool     mLocked; ///< is deck locked from adding/removing?
    CardList mCards;  ///< cards in deck
    DeckMode mMode;   ///< deck mode

    std::list<Listener> mListeners; ///< update listeners

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Adds a card to the deck
    /// @param card - card to add
    /// @param sort - sort after adding?
    /// @return - None
    ///////////////////////////////////////////////////////////////////////////
    void addCard(const Card& card, bool sort);

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Notifies all listeners that the deck has been updated
    /// @return - None
    ///////////////////////////////////////////////////////////////////////////
    void notify();

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Removes the next card from the deck without notifying listeners
    /// @param card[out] - next card
    /// @return - true if deck is nonempty, else false
    ///////////////////////////////////////////////////////////////////////////
    bool popCard(Card& card);

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Removes the requested card without notifying listeners
    ///   NOTE: If multiple instances of card in the deck, removes first one
    /// @param card - card to remove
    /// @return - true if card is present in the deck, else false
    ///////////////////////////////////////////////////////////////////////////
    bool removeCard(const Card& card);

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Sets whether the deck is locked for editing
    /// @param locked - true if locked, else false
    /// @return - None
    ///////////////////////////////////////////////////////////////////////////
    void setLocked(bool locked) { mLocked = locked; }

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Sorts the cards in the deck
    /// @return - None
    ///////////////////////////////////////////////////////////////////////////
    void sortCards();
  };

} // namespace Phase10
